<?php

namespace App\Models;

use App\Models\Traits\HasSystemLog;
use Illuminate\Database\Eloquent\Builder;
use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\Relations\HasOne;
use Illuminate\Database\Eloquent\SoftDeletes;
use Illuminate\Support\Facades\Auth;

class Staff extends User
{
    use HasFactory;
    use SoftDeletes;
    use HasSystemLog;
    protected $table = "users";
    protected $guarded = ["id"];
    protected  $appends = [
        'last_login',
        'login_warning'
    ];
    protected static function boot()
    {
        parent::boot(); // TODO: Change the autogenerated stub
        static::addGlobalScope('role', function (Builder $builder) {
            $builder->where('role', User::STAFF_ROLE);
        });
        static::addGlobalScope('branch', function (Builder $builder) {
            $builder->where('branch', Auth::user()->{'branch'});
        });
    }

    public function profile(): HasOne
    {
        return $this->hasOne(StaffProfile::class, "user_id", "id");
    }

    public function getCustomField(mixed $name)
    {
        $extraInformation = $this->profile?->extra_information;

        if (!$extraInformation) {
            return null;
        }


        $extraInformation = json_decode($extraInformation, true);

        return $extraInformation[$name] ?? null;
    }
}
